#include <iostream>
#include <gmpxx.h>
#include <gmp.h>
#include <time.h>
using namespace std;

mpz_class euklid(mpz_class a,mpz_class b)
{
    mpz_class r;
    if(a < b) { r = a; a = b; b = r; };
    while(b > 0) { r = a % b; a = b; b = r; };
    return a;
}

mpz_class binnsd(mpz_class a,mpz_class b)
{
    long e=0;
    mpz_class r;
    while(a%2==0 && b%2==0) { e++; a>>=1; b>>=1; };
    if(a%2==0) { r=a; a=b; b=r; };
    while(b > 0)
        {
            r=b; while((r%2)==0) { r>>=1; };    // r=b/(2^c)
            b=abs(a-r);         // b=|a-r|
            if(r<a) { a=r; };   // a=min(a,r)
            };
    return a<<e;   // 2^e*a
}

void mereni(long mez1, long mez2, long krok, long opak)
{
    int i,j;
    mpz_class a,b,c;
    clock_t t0,t1;
    double tt;

    gmp_randclass r(gmp_randinit_default);
    r.seed(time(0));

    cout << "{";

    for(i=mez1;i<=mez2;i+=krok) {
        a = r.get_z_bits(i);
        b = r.get_z_bits(i);

        t0 = clock();
        for(j=0;j<opak;j++)
//            { c=euklid(a,b); };
            { c=binnsd(a,b); };
//            { mpz_gcd(c.get_mpz_t(),a.get_mpz_t(),b.get_mpz_t()); };
        t1 = clock();

        tt=t1-t0;
        cout << "{" << i << "," << tt/CLOCKS_PER_SEC << "}, " ;
    }
    cout << "}" << endl;
}

int main()
{
    mereni(500,10000,500,50);
    return 0;
}

/*
int main()
{
    mpz_class a,b,c;
    cin >> a; cin >> b;
    c=euklid(a,b);
    cout << c << endl;
    c=binnsd(a,b);
    cout << c << endl;
    return 0;
}
*/
